Search documentation of stdlib

# erl_pp (stdlib v7.3)

Copy Markdown View Source

The Erlang pretty printer.

The functions in this module are used to generate aesthetically attractive representations of abstract forms, which are suitable for printing. All functions return (possibly deep) lists of characters and generate an error if the form is wrong.

All functions can have an optional argument, which specifies a hook that is called if an attempt is made to print an unknown form.

Note that if the functions in this module are used to convert abstract code back to Erlang source code, the enclosing function should first be processed by `legalize_vars/1` in order to ensure that the output is semantically equivalent to the abstract code.

## Known Limitations

It is not possible to have hook functions for unknown forms at other places than expressions.

## See Also

`erl_eval`, `erl_parse`, `io`

## Summary

### Types

hook_function()

Optional argument `HookFunction`, shown in the functions described in this module, defines a function that is called when an unknown form occurs where there is to be a valid expression. If `HookFunction` is equal to `none`, there is no hook function.

option()

The option `quote_singleton_atom_types` is used to add quotes to all singleton atom types.

options()

### Functions

attribute(Attribute)

Equivalent to `attribute(Attribute, none)`.

attribute(Attribute, Options)

Same as `form/1,2`, but only for attribute `Attribute`.

expr(Expression)

Equivalent to `expr(Expression, none)`.

expr(Expression, Options)

Equivalent to `expr(Expression, 0, Options)`.

expr(Expression, Indent, Options)

Equivalent to `expr(Expression, Indent, 0, Options)`.

expr(Expression, Indent, Precedence, Options)

Prints one expression.

exprs(Expressions)

Equivalent to `exprs(Expressions, none)`.

exprs(Expressions, Options)

Equivalent to `exprs(Expressions, 0, Options)`.

exprs(Expressions, Indent, Options)

Same as `form/1,2`, but only for the sequence of expressions in `Expressions`.

form(Form)

Equivalent to `form(Form, none)`.

form(Form, Options)

Pretty prints a `Form`, which is an abstract form of a type that is returned by `erl_parse:parse_form/1`.

function(Function)

Equivalent to `function(Function, none)`.

function(Function, Options)

Same as `form/1,2`, but only for function `Function`.

guard(Guard)

Equivalent to `guard(Guard, none)`.

guard(Guard, Options)

Same as `form/1,2`, but only for the guard test `Guard`.

legalize_vars(Function)

The Erlang compiler will, when expanding records to tuples, introduce new variables in the abstract representation. As the expansion is done on the abstract representation, the compiler can safely name the new variables with names that are not syntactically valid in Erlang source code (the name starts with a lowercase letter), thus ensuring the uniqueness of the new names.

## Types

# hook_function()

(not exported)

    -type hook_function() ::
              none |
              fun((Expr :: erl_parse:abstract_expr(),
                   CurrentIndentation :: integer(),
                   CurrentPrecedence :: non_neg_integer(),
                   Options :: options()) ->
                      io_lib:chars()).

Optional argument `HookFunction`, shown in the functions described in this module, defines a function that is called when an unknown form occurs where there is to be a valid expression. If `HookFunction` is equal to `none`, there is no hook function.

The called hook function is to return a (possibly deep) list of characters. Function `expr/4` is useful in a hook.

If `CurrentIndentation` is negative, there are no line breaks and only a space is used as a separator.

# option()

(not exported)

    -type option() ::
              {hook, hook_function()} |
              {encoding, latin1 | unicode | utf8} |
              {quote_singleton_atom_types, boolean()} |
              {linewidth, pos_integer()} |
              {indent, pos_integer()}.

The option `quote_singleton_atom_types` is used to add quotes to all singleton atom types.

The option `linewidth` controls the maximum line width for formatted lines (defaults to 72 characters).

The option `indent` controls the indention for formatted lines (defaults to 4 spaces).

# options()

(not exported)

    -type options() :: hook_function() | [option()].

## Functions

# attribute(Attribute)

    -spec attribute(Attribute) -> io_lib:chars() when Attribute :: erl_parse:abstract_form().

Equivalent to `attribute(Attribute, none)`.

# attribute(Attribute, Options)

    -spec attribute(Attribute, Options) -> io_lib:chars()
                       when Attribute :: erl_parse:abstract_form(), Options :: options().

Same as `form/1,2`, but only for attribute `Attribute`.

# expr(Expression)

    -spec expr(Expression) -> io_lib:chars() when Expression :: erl_parse:abstract_expr().

Equivalent to `expr(Expression, none)`.

# expr(Expression, Options)

    -spec expr(Expression, Options) -> io_lib:chars()
                  when Expression :: erl_parse:abstract_expr(), Options :: options().

Equivalent to `expr(Expression, 0, Options)`.

# expr(Expression, Indent, Options)

    -spec expr(Expression, Indent, Options) -> io_lib:chars()
                  when Expression :: erl_parse:abstract_expr(), Indent :: integer(), Options :: options().

Equivalent to `expr(Expression, Indent, 0, Options)`.

# expr(Expression, Indent, Precedence, Options)

    -spec expr(Expression, Indent, Precedence, Options) -> io_lib:chars()
                  when
                      Expression :: erl_parse:abstract_expr(),
                      Indent :: integer(),
                      Precedence :: non_neg_integer(),
                      Options :: options().

Prints one expression.

It is useful for implementing hooks (see section Known Limitations).

# exprs(Expressions)

    -spec exprs(Expressions) -> io_lib:chars() when Expressions :: [erl_parse:abstract_expr()].

Equivalent to `exprs(Expressions, none)`.

# exprs(Expressions, Options)

    -spec exprs(Expressions, Options) -> io_lib:chars()
                   when Expressions :: [erl_parse:abstract_expr()], Options :: options().

Equivalent to `exprs(Expressions, 0, Options)`.

# exprs(Expressions, Indent, Options)

    -spec exprs(Expressions, Indent, Options) -> io_lib:chars()
                   when
                       Expressions :: [erl_parse:abstract_expr()], Indent :: integer(), Options :: options().

Same as `form/1,2`, but only for the sequence of expressions in `Expressions`.

# form(Form)

    -spec form(Form) -> io_lib:chars() when Form :: erl_parse:abstract_form() | erl_parse:form_info().

Equivalent to `form(Form, none)`.

# form(Form, Options)

    -spec form(Form, Options) -> io_lib:chars()
                  when Form :: erl_parse:abstract_form() | erl_parse:form_info(), Options :: options().

Pretty prints a `Form`, which is an abstract form of a type that is returned by `erl_parse:parse_form/1`.

# function(Function)

    -spec function(Function) -> io_lib:chars() when Function :: erl_parse:abstract_form().

Equivalent to `function(Function, none)`.

# function(Function, Options)

    -spec function(Function, Options) -> io_lib:chars()
                      when Function :: erl_parse:abstract_form(), Options :: options().

Same as `form/1,2`, but only for function `Function`.

# guard(Guard)

    -spec guard(Guard) -> io_lib:chars() when Guard :: [erl_parse:abstract_expr()].

Equivalent to `guard(Guard, none)`.

# guard(Guard, Options)

    -spec guard(Guard, Options) -> io_lib:chars()
                   when Guard :: [erl_parse:abstract_expr()], Options :: options().

Same as `form/1,2`, but only for the guard test `Guard`.

# legalize_vars(Function)

(since OTP 25.0)

    -spec legalize_vars(Function) -> erl_parse:abstract_form() when Function :: erl_parse:abstract_form().

The Erlang compiler will, when expanding records to tuples, introduce new variables in the abstract representation. As the expansion is done on the abstract representation, the compiler can safely name the new variables with names that are not syntactically valid in Erlang source code (the name starts with a lowercase letter), thus ensuring the uniqueness of the new names.

The above strategy leads to problems if a user wants to convert the abstract representation, using the functions of this module back to Erlang source code. Typically, pattern variables are output as atoms thus changing the sematics of the program. To solve this problem `legalize_vars/1`, when run on the abstract representation of a function, will return an equivalent function where all variables will have syntactically valid names.